#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire900three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire900three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three9004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three9004xi = {
                1:'0x17y-899z',
                2:'0x26y-899z',
                3:'0x873y-216z',
                4:'0x8y-899z',
                5:'104x110y-887z',
                6:'10x220y-872z',
                7:'112x257y-854z',
                8:'113x809y-376z',
                9:'117x110y-885z',
                10:'120x768y-628z',
                11:'129x109y-883z',
                12:'12x750y-496z',
                13:'130x259y-852z',
                14:'132x753y-474z',
                15:'137x868y-190z',
                16:'142x108y-882z',
                17:'145x690y-558z',
                18:'147x259y-849z',
                19:'14x18y-899z',
                20:'14x60y-897z',
                21:'154x105y-880z',
                22:'156x806y-367z',
                23:'165x258y-846z',
                24:'172x750y-466z',
                25:'182x687y-551z',
                26:'183x256y-842z',
                27:'183x862y-181z',
                28:'199x800y-359z',
                29:'202x252y-839z',
                30:'20x68y-897z',
                31:'213x744y-458z',
                32:'21x23y-899z',
                33:'220x248y-836z',
                34:'220x681y-544z',
                35:'228x853y-172z',
                36:'22x228y-870z',
                37:'239x242y-833z',
                38:'242x792y-351z',
                39:'253x736y-450z',
                40:'257x234y-829z',
                41:'257x674y-537z',
                42:'273x841y-163z',
                43:'276x226y-826z',
                44:'27x75y-896z',
                45:'284x781y-343z',
                46:'28x809y-392z',
                47:'293x726y-443z',
                48:'294x216y-822z',
                49:'294x665y-529z',
                50:'29x28y-899z',
                51:'2x35y-899z',
                52:'2x4y-899z',
                53:'312x205y-818z',
                54:'317x827y-154z',
                55:'326x769y-334z',
                56:'331x653y-522z',
                57:'332x714y-435z',
                58:'34x82y-895z',
                59:'35x235y-867z',
                60:'361x811y-145z',
                61:'367x639y-515z',
                62:'367x753y-326z',
                63:'371x699y-427z',
                64:'37x33y-898z',
                65:'403x623y-507z',
                66:'403x792y-136z',
                67:'408x736y-317z',
                68:'409x682y-419z',
                69:'42x88y-894z',
                70:'438x605y-500z',
                71:'445x771y-128z',
                72:'447x663y-411z',
                73:'447x716y-309z',
                74:'45x874y-207z',
                75:'46x36y-898z',
                76:'472x585y-492z',
                77:'483x642y-403z',
                78:'485x748y-119z',
                79:'486x694y-301z',
                80:'49x241y-865z',
                81:'506x564y-485z',
                82:'519x619y-395z',
                83:'51x94y-893z',
                84:'524x670y-292z',
                85:'525x722y-110z',
                86:'52x753y-489z',
                87:'538x540y-477z',
                88:'553x594y-387z',
                89:'55x39y-897z',
                90:'560x644y-283z',
                91:'562x694y-101z',
                92:'569x514y-470z',
                93:'586x567y-379z',
                94:'595x616y-275z',
                95:'599x486y-462z',
                96:'599x665y-92z',
                97:'5x44y-898z',
                98:'618x538y-370z',
                99:'61x99y-892z',
                100:'627x457y-454z',
                101:'628x586y-266z',
                102:'633x633y-83z',
                103:'648x507y-362z',
                104:'64x247y-862z',
                105:'660x554y-258z',
                106:'666x600y-74z',
                107:'677x474y-354z',
                108:'690x520y-249z',
                109:'697x564y-65z',
                110:'70x810y-384z',
                111:'718x484y-240z',
                112:'71x103y-891z',
                113:'726x527y-56z',
                114:'80x251y-860z',
                115:'82x106y-889z',
                116:'8x11y-899z',
                117:'91x872y-198z',
                118:'92x754y-481z',
                119:'93x108y-888z',
                120:'96x255y-857z',
                121:'9x52y-898z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire900three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire900three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE900THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE900THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE900THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE900THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE900THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three9004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE900THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE900THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE900THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three9004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three8shot2three9004xi</nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE900THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE900THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE900THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire900three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                